GStreamer with VPU support on i.MX 8M Mini EVK

cancel
Showing results for 
Search instead for 
Did you mean: 

GStreamer with VPU support on i.MX 8M Mini EVK

1,933 Views
mattia_dalben
Contributor I

Hi,

I'm trying to build an image with yocto which support gstreamer with vpu plugins (I need the h264 hardware encoder). I added the following to my local.conf:

IMAGE_INSTALL_append = " gstreamer1.0 gstreamer1.0-plugins-base gstreamer1.0-plugins-good gstreamer1.0-plugins-bad gstreamer1.0-plugins-ugly gstreamer1.0-libav imx-vpuwrap imx-gst1.0-plugins"
LICENSE_FLAGS_WHITELIST = "commercial"

The starting point for my build is the "NXP eIQ Machine Learning Software Development Environment for i.MX Applications Processors" document (see attached).

But I get the following error:

$ bitbake fsl-image-qt5
WARNING: You have included the meta-virtualization layer, but 'virtualization' has not been enabled in your DISTRO_FEATURES. Some bbappend files may not take effect. See the meta-virtualization README for details on enabling virtualization support.
Loading cache: 100% |######################################################################################################################################################################################################################################################| Time: 0:00:00
Loaded 3584 entries from dependency cache.
NOTE: Resolving any missing task queue dependencies
ERROR: Nothing RPROVIDES 'imx-gst1.0-plugins' (but /media/mattia/HD500GB/NXPeIQiMX8MMMini/fsl-arm-yocto-bsp/sources/meta-fsl-bsp-release/imx/meta-sdk/dynamic-layers/qt5-layer/recipes-fsl/images/fsl-image-qt5.bb RDEPENDS on or otherwise requires it)
NOTE: Runtime target 'imx-gst1.0-plugins' is unbuildable, removing...
Missing or unbuildable dependency chain was: ['imx-gst1.0-plugins']
ERROR: Required build target 'fsl-image-qt5' has no buildable providers.
Missing or unbuildable dependency chain was: ['fsl-image-qt5', 'imx-gst1.0-plugins']

Summary: There was 1 WARNING message shown.
Summary: There were 2 ERROR messages shown, returning a non-zero exit code.

How can I fix this?

0 Kudos
5 Replies

1,418 Views
igorpadykov
NXP TechSupport
NXP TechSupport

Hi Mattia

may be recommended to follow Yocto Guide (sect.5.1 Build configurations,

sect.5.2 Choosing an i.MX Yocto project image) included 

in official Linux documentation Linux 4.19.35_1.1.0 Documentation

i.MX Software and Development Tools | NXP 

Best regards
igor
-----------------------------------------------------------------------------------------------------------------------
Note: If this post answers your question, please click the Correct Answer button. Thank you!
-----------------------------------------------------------------------------------------------------------------------

0 Kudos

1,418 Views
mattia_dalben
Contributor I

Hi Igor,

thanks for the quick answer but this doesn't solve my problem. I can already build an image successfully, I wanted to add the GStreamer plugin to leverage the VPU for h264 hardware encoding.

As I said the problem is related to:

ERROR: Nothing RPROVIDES 'imx-gst1.0-plugins' (but /media/mattia/HD500GB/NXPeIQiMX8MMMini/fsl-arm-yocto-bsp/sources/meta-fsl-bsp-release/imx/meta-sdk/dynamic-layers/qt5-layer/recipes-fsl/images/fsl-image-qt5.bb RDEPENDS on or otherwise requires it)

Which layer provides imx-gst1.0-plugins which contains the VPU accelerated GStreamer plugins?

0 Kudos

1,418 Views
igorpadykov
NXP TechSupport
NXP TechSupport

from sect.2 Features attached Yocto Guide:

"Multimedia recipes
• Multimedia recipes reside in recipes-multimedia.
• Recipes include imx-codec, imx-parser, libvpuwrap, and imx-gstreamer-plugins that pull from the i.MX mirror to
build and package into image recipes."

recipes-multimedia\meta-bsp\imx - meta-fsl-bsp-release - i.MX Yocto Project Release Layer 

Best regards
igor

0 Kudos

1,418 Views
mattia_dalben
Contributor I

I've added the layer in the bblayers.conf file as follows:

LCONF_VERSION = "7"

BBPATH = "${TOPDIR}"
BSPDIR := "${@os.path.abspath(os.path.dirname(d.getVar('FILE', True)) + '/../..')}"

BBFILES ?= ""
BBLAYERS = " \
${BSPDIR}/sources/poky/meta \
${BSPDIR}/sources/poky/meta-poky \
\
${BSPDIR}/sources/meta-openembedded/meta-oe \
${BSPDIR}/sources/meta-openembedded/meta-multimedia \
\
${BSPDIR}/sources/meta-freescale \
${BSPDIR}/sources/meta-freescale-3rdparty \
${BSPDIR}/sources/meta-freescale-distro \
"

# i.MX Yocto Project Release layers
BBLAYERS += " ${BSPDIR}/sources/meta-fsl-bsp-release/imx/meta-bsp "
BBLAYERS += " ${BSPDIR}/sources/meta-fsl-bsp-release/imx/meta-sdk "

BBLAYERS += " ${BSPDIR}/sources/meta-browser "
BBLAYERS += " ${BSPDIR}/sources/meta-openembedded/meta-gnome "
BBLAYERS += " ${BSPDIR}/sources/meta-openembedded/meta-networking "
BBLAYERS += " ${BSPDIR}/sources/meta-openembedded/meta-python "
BBLAYERS += " ${BSPDIR}/sources/meta-openembedded/meta-filesystems "
BBLAYERS += " ${BSPDIR}/sources/meta-qt5 "
BBLAYERS += " ${BSPDIR}/sources/meta-virtualization "

But the error keeps showing:

ERROR: Nothing RPROVIDES 'imx-gst1.0-plugins' (but /media/mattia/HD500GB/NXPeIQiMX8MMMini/fsl-arm-yocto-bsp/sources/meta-fsl-bsp-release/imx/meta-sdk/dynamic-layers/qt5-layer/recipes-fsl/images/fsl-image-qt5.bb RDEPENDS on or otherwise requires it)
NOTE: Runtime target 'imx-gst1.0-plugins' is unbuildable, removing...
Missing or unbuildable dependency chain was: ['imx-gst1.0-plugins']
ERROR: Required build target 'fsl-image-qt5' has no buildable providers.
Missing or unbuildable dependency chain was: ['fsl-image-qt5', 'imx-gst1.0-plugins']

0 Kudos

1,418 Views
igorpadykov
NXP TechSupport
NXP TechSupport

imx-gst1.0-plugin_4.4.6.bb\gstreamer\recipes-multimedia\meta-bsp\imx - meta-fsl-bsp-release - i.MX Y... 

suggest to build image as described in Yocto Guide:

image "imx-image-multimedia" described in Table 1. i.MX Yocto project images,

machine configuration as "imx8mmevk" described in sect.5.1 Build configurations

Best regards
igor

0 Kudos